<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { computed, ref, toRef } from 'vue';

const props = defineProps<{
    modelValue: string,
    onChange?: (e:any) => void,
    hideIcon?: boolean,
}>();

const modelValue = toRef(props, 'modelValue');
const inputRef = ref(null);

const emits = defineEmits<{
    (e: 'update:modelValue', value: string): void
}>();

const localValue = computed({
    get: () => modelValue.value,
    set: (value) => emits(`update:modelValue`, value)
});
</script>
<template>
    <div class="w-full min-h-5 h-full gap-3 inline-flex">
        <i class="ri-sip-line mt-0.5" v-if="!hideIcon"></i>
        <label class="w-full" id="color-swatch">
            <div class="min-h-5 h-full border border-gray-300 rounded-md w-full bg-gray-700 px-0.5"
                :style="{ background: props.modelValue ? props.modelValue : '' }"></div>
            <input ref="inputRef" type="color" class="absolute h-5 opacity-0 -mt-5 -ml-2.5 w-5" v-model="localValue"
                @change="onChange" />
        </label>
    </div>
</template>